<?php
/**
 * @copyright	Copyright (C) 2009-2010 HIKARI SOFTWARE SARL - All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class plgSystemRecaptcha extends JPlugin
{
	function plgSystemRecaptcha(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin =& JPluginHelper::getPlugin('system', 'recaptcha');
			jimport('joomla.html.parameter');
			$this->params = new JParameter( $plugin->params );
		}
	}

	function onAfterDispatch(){
		$theme = $this->params->get('theme');
		$lang = &JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));
		if(!in_array($locale,array('en','nl','fr','de','pt','ru','es','tr'))) $locale = 'en';
		$js='';
		if($theme!='red'){
			$js="theme : '".$theme."'";
		}
		if($locale!='en'){
			if(!empty($js)) $js.=',';
			$js.="lang : '".$locale."'";
		}
		if(!empty($js)){
			$js = 'var RecaptchaOptions = {'.$js.'};';
			$doc =& JFactory::getDocument();
			$doc->addScriptDeclaration($js);
		}
	}

	function onAfterRender(){
		$option = JRequest::getString('option');

		if(empty($option)) return;

		$user = JFactory::getUser();
		if (!$user->guest) {
			return true;
		}

		$components = array();
		$components['com_user'] = array('view' => array('register'),'lengthafter' => 200);
		$components['com_users'] = array('view' => array('registration'),'lengthafter' => 200, 'email' => 'jform\[email2\]', 'password' => 'jform\[password2\]');
		$components['com_alpharegistration'] = array('view' => array('register'),'lengthafter' => 250);
		$components['com_ccusers'] = array('view' => array('register'),'lengthafter' => 500);
		$components['com_virtuemart'] = array('view' => array('shop.registration'),'viewvar' => 'page','lengthafter' => 500);
		$components['com_hikashop'] = array('view' => array('checkout','user'),'viewvar' => 'ctrl', 'lengthafter' => 500 , 'tdclass' => 'key', 'email' => 'data\[register\]\[email\]','password' => 'data\[register\]\[password2\]');
		if($this->params->get('contact',0)){
			$components['com_hikashop']['view'][]='product';
			$components['com_hikashop']['contact']=1;
			$components['com_contact'] = array('view' => array('contact'),'lengthafter' => 200,'contact'=>1);
			if(version_compare(JVERSION,'1.6','>=')){
				$components['com_contact']['contact_text'] = 'jform_contact_message';
				$components['com_contact']['contact_email'] = 'jform_contact_email';
				$components['com_contact']['contact_email_copy'] = 'jform_contact_email_copy';
			}
			$components['com_gcontact'] = array('view' => array('registration'),'lengthafter' => 200,'contact'=>1);
			$components['com_qcontacts'] = array('view' => array('contact'),'lengthafter' => 400,'contact'=>1);
			$components['com_contact_enhanced'] = array('view' => array('contact'),'lengthafter' => 200,'contact'=>1, 'contact_text' => 'cf_4', 'contact_email' => 'email');
		}

		if(!isset($components[$option])) return;
		$viewVar = (isset($components[$option]['viewvar']) ? $components[$option]['viewvar'] : 'view');
		if(!in_array(JRequest::getString($viewVar,JRequest::getString('task')),$components[$option]['view'])) return;

		$subText = $this->params->get('captchatext');
		if(empty($subText)){
			$subText = JText::_('Captcha').':';
		}
		$body = JResponse::getBody();

		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php')) return true;

		if(!empty($components[$option]['contact'])){
			$id = $this->params->get('checkpos','contact_text');
			if($option=='com_hikashop'){
				switch($id){
					case 'contact_email_copy':
					case 'contact_email':
						$after = 'data\[register\]\[email\]';
						break;
					case 'contact_text':
					default:
						$after = 'data\[register\]\[altbody\]';
						break;
				}
				$c = new hikaShopRecaptcha();
				$return = '<tr class="hikashop_captcha"><td valign="top">'.$subText.'</td><td>'.$c->recaptcha_get_html($this->params->get('public_key'),null,hikashop_isSSL()).'</td></tr>';
				$replace= 'name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</tr>';
			}else{
				$c = new hikaShopRecaptcha();
				if($option=='com_contact' && version_compare(JVERSION,'1.6','>=')){
					$return = '<dt>'.$subText.'</dt>';
					$return .= '<dd class="hikashop_captcha">'.$c->recaptcha_get_html($this->params->get('public_key'),null,hikashop_isSSL()).'</dd>';
				}else{
					$return = '<label>'.$subText.'</label><br/>';
					$return .= '<span class="hikashop_captcha">'.$c->recaptcha_get_html($this->params->get('public_key'),null,hikashop_isSSL()).'</span><br />';
				}
				if(isset($components[$option][$id])) $id = $components[$option][$id];
				$replace = 'id="'.$id.'".{0,'.$components[$option]['lengthafter'].'}(<br */>|</p>|</div>|</dd>)';
			}

			if(preg_match('#'.$replace.'#Uis',$body)){
				$body = preg_replace('#('.$replace.')#Uis','$1'.$return,$body,1);
				JResponse::setBody($body);
				return;
			}
			if($option!='com_hikashop'){
				return true;
			}
		}

		if(!empty($components[$option][$this->params->get('fieldafter','password')])){
			$after = $components[$option][$this->params->get('fieldafter','password')];
		}else{
			if($this->params->get('fieldafter','password') == 'custom'){ $after =  $this->params->get('fieldaftercustom'); }
			else{ $after = ($this->params->get('fieldafter','password') == 'email') ? 'email' : 'password2'; }
		}
		$c = new hikaShopRecaptcha();
		$return = $c->recaptcha_get_html($this->params->get('public_key'),null,hikashop_isSSL());

		if(preg_match('#(name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</tr>)#Uis',$body)){
			$return = '<tr class="recaptcha"><td valign="top">'.$subText.'</td><td>'.$return.'</td></tr>';
			$body = preg_replace('#(name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</tr>)#Uis','$1'.$return,$body,1);
			JResponse::setBody($body);
			return;
		}
		if(preg_match('#(name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</div>)#Uis',$body)){
			$return = '<div class="recaptcha"><label>'.$subText.'</label>'.$return.'</div>';
			$body = preg_replace('#(name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</div>)#Uis','$1'.$return,$body,1);
			JResponse::setBody($body);
			return;
		}
		if(preg_match('#(name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</p>)#Uis',$body)){
			$return = '<div class="recaptcha"><label>'.$subText.'</label>'.$return.'</div>';
			$body = preg_replace('#(name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</p>)#Uis','$1'.$return,$body,1);
			JResponse::setBody($body);
			return;
		}
		if(preg_match('#(name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</dd>)#Uis',$body)){
			$return = '<dt class="recaptcha"><label>'.$subText.'</label></dt><dd>'.$return.'</dd>';
			$body = preg_replace('#(name="'.$after.'".{0,'.$components[$option]['lengthafter'].'}</dd>)#Uis','$1'.$return,$body,1);
			JResponse::setBody($body);
			return;
		}
	}

	function onUserBeforeSave($user, $isnew, $new){
		return $this->onBeforeStoreUser($user, $isnew);
	}

	function onSubmitContact($contact,$post){
		$app =& JFactory::getApplication();
		if ($app->isAdmin()) return true;
		if(!isset($this->params)){
			$plugin =& JPluginHelper::getPlugin('system', 'recaptcha');
			$this->params = new JParameter( $plugin->params );
		}
		if(!$this->params->get('contact',0)){
			return true;
		}
		return $this->_checkCaptcha();
	}

	function onBeforeSendContactRequest(&$element,&$send){
		$app =& JFactory::getApplication();
		if ($app->isAdmin()) return true;
		if(!isset($this->params)){
			$plugin =& JPluginHelper::getPlugin('system', 'recaptcha');
			$this->params = new JParameter( $plugin->params );
		}
		if(!$this->params->get('contact',0)){
			return true;
		}
		$send = $this->_checkCaptcha();
		return true;
	}

	function onBeforeStoreUser($user, $isnew, $new=null){
		if(!$isnew) return true;

		$app =& JFactory::getApplication();
		if ($app->isAdmin()) return true;

		if(!isset($this->params)){
			$plugin =& JPluginHelper::getPlugin('system', 'recaptcha');
			$this->params = new JParameter( $plugin->params );
		}
		return $this->_checkCaptcha();
	}

	function _checkCaptcha(){
		$user = JFactory::getUser();
		if (!$user->guest) {
			return true;
		}
		$c = new hikaShopRecaptcha();
		$resp = $c->recaptcha_check_answer($this->params->get('private_key'), @$_SERVER["REMOTE_ADDR"], @$_POST["recaptcha_challenge_field"], @$_POST["recaptcha_response_field"]);
		if (!$resp->is_valid) {
			switch($resp->error){
				default:
					$resp->error = 'Unknown error';
					break;
				case 'invalid-site-public-key':
					$resp->error = 'ReCaptcha couldn\'t verify the public key';
					break;
				case 'invalid-site-private-key':
					$resp->error = 'ReCaptcha couldn\'t verify the private key';
					break;
				case 'invalid-request-cookie':
					$resp->error = 'The challenge parameter of the verify script was incorrect';
					break;
				case 'incorrect-captcha-sol':
					$resp->error = 'The CAPTCHA solution was incorrect';
					break;
				case 'verify-params-incorrect':
					$resp->error = 'The parameters were incorrect, make sure you are passing all the required parameters';
					break;
				case 'invalid-referrer':
					$resp->error = 'Invalid referer, reCAPTCHA API keys are tied to a specific domain name for security reasons';
					break;
				case 'recaptcha-not-reachable':
					$resp->error = 'We couldn\'t contact the reCAPTCHA server to verify your answer. Please try again.';
					break;
			}
			$app=&JFactory::getApplication();
			$app->redirect(@$_SERVER['HTTP_REFERER'],$resp->error,'error');
			return false;
		}
		return true;
	}

}//endclass

/**
 * The reCAPTCHA server URL's
 */
//define("RECAPTCHA_API_SERVER", "http://www.google.com/recaptcha/api");
//define("RECAPTCHA_API_SECURE_SERVER", "https://www.google.com/recaptcha/api");
//define("RECAPTCHA_VERIFY_SERVER", "www.google.com");

class hikaShopRecaptcha{

	var $RECAPTCHA_API_SERVER = "http://www.google.com/recaptcha/api";
	var $RECAPTCHA_API_SECURE_SERVER = "https://www.google.com/recaptcha/api";
	var $RECAPTCHA_VERIFY_SERVER = "www.google.com";

	/**
	 * Encodes the given data into a query string format
	 * @param $data - array of string elements to be encoded
	 * @return string - encoded request
	 */
	function _recaptcha_qsencode ($data) {
		$req = "";
		foreach ( $data as $key => $value )
						$req .= $key . '=' . urlencode( stripslashes($value) ) . '&';

		// Cut the last '&'
		$req=substr($req,0,strlen($req)-1);
		return $req;
	}



	/**
	 * Submits an HTTP POST to a reCAPTCHA server
	 * @param string $host
	 * @param string $path
	 * @param array $data
	 * @param int port
	 * @return array response
	 */
	function _recaptcha_http_post($host, $path, $data, $port = 80) {

		$req = $this->_recaptcha_qsencode ($data);

		$http_request  = "POST $path HTTP/1.0\r\n";
		$http_request .= "Host: $host\r\n";
		$http_request .= "Content-Type: application/x-www-form-urlencoded;\r\n";
		$http_request .= "Content-Length: " . strlen($req) . "\r\n";
		$http_request .= "User-Agent: reCAPTCHA/PHP\r\n";
		$http_request .= "\r\n";
		$http_request .= $req;

		$response = '';
		if( false == ( $fs = @fsockopen($host, $port, $errno, $errstr, 10) ) ) {
						die ('Could not open socket');
		}

		fwrite($fs, $http_request);

		while ( !feof($fs) )
						$response .= fgets($fs, 1160); // One TCP-IP packet
		fclose($fs);
		$response = explode("\r\n\r\n", $response, 2);

		return $response;
	}



	/**
	 * Gets the challenge HTML (javascript and non-javascript version).
	 * This is called from the browser, and the resulting reCAPTCHA HTML widget
	 * is embedded within the HTML form it was called from.
	 * @param string $pubkey A public key for reCAPTCHA
	 * @param string $error The error given by reCAPTCHA (optional, default is null)
	 * @param boolean $use_ssl Should the request be made over ssl? (optional, default is false)

	 * @return string - The HTML to be embedded in the user's form.
	 */
	function recaptcha_get_html ($pubkey, $error = null, $use_ssl = false)
	{
		if ($pubkey == null || $pubkey == '') {
			die ("To use reCAPTCHA you must get an API key from <a href='https://www.google.com/recaptcha/admin/create'>https://www.google.com/recaptcha/admin/create</a>");
		}

		if ($use_ssl) {
									$server = $this->RECAPTCHA_API_SECURE_SERVER;
					} else {
									$server = $this->RECAPTCHA_API_SERVER;
					}

					$errorpart = "";
					if ($error) {
						 $errorpart = "&amp;error=" . $error;
					}
					return '<script type="text/javascript" src="'. $server . '/challenge?k=' . $pubkey . $errorpart . '"></script>

		<noscript>
				<iframe src="'. $server . '/noscript?k=' . $pubkey . $errorpart . '" height="300" width="500" frameborder="0"></iframe><br/>
				<textarea name="recaptcha_challenge_field" rows="3" cols="40"></textarea>
				<input type="hidden" name="recaptcha_response_field" value="manual_challenge"/>
		</noscript>';
	}







	/**
	* Calls an HTTP POST function to verify if the user's guess was correct
	* @param string $privkey
	* @param string $remoteip
	* @param string $challenge
	* @param string $response
	* @param array $extra_params an array of extra variables to post to the server
	* @return ReCaptchaResponse
	*/
	function recaptcha_check_answer ($privkey, $remoteip, $challenge, $response, $extra_params = array())
	{
		if ($privkey == null || $privkey == '') {
			die ("To use reCAPTCHA you must get an API key from <a href='https://www.google.com/recaptcha/admin/create'>https://www.google.com/recaptcha/admin/create</a>");
		}

		if ($remoteip == null || $remoteip == '') {
			die ("For security reasons, you must pass the remote ip to reCAPTCHA");
		}


		//discard spam submissions
		if ($challenge == null || strlen($challenge) == 0 || $response == null || strlen($response) == 0) {
						$recaptcha_response = new HikaShopReCaptchaResponse();
						$recaptcha_response->is_valid = false;
						$recaptcha_response->error = 'incorrect-captcha-sol';
						return $recaptcha_response;
		}

		$response = $this->_recaptcha_http_post ($this->RECAPTCHA_VERIFY_SERVER, "/recaptcha/api/verify",
																			array (
																						 'privatekey' => $privkey,
																						 'remoteip' => $remoteip,
																						 'challenge' => $challenge,
																						 'response' => $response
																						 ) + $extra_params
																			);

		$answers = explode ("\n", $response [1]);
		$recaptcha_response = new HikaShopReCaptchaResponse();

		if (trim ($answers [0]) == 'true') {
						$recaptcha_response->is_valid = true;
		}
		else {
						$recaptcha_response->is_valid = false;
						$recaptcha_response->error = $answers [1];
		}
		return $recaptcha_response;

	}

	/**
	 * gets a URL where the user can sign up for reCAPTCHA. If your application
	 * has a configuration page where you enter a key, you should provide a link
	 * using this function.
	 * @param string $domain The domain where the page is hosted
	 * @param string $appname The name of your application
	 */
	function recaptcha_get_signup_url ($domain = null, $appname = null) {
		return "https://www.google.com/recaptcha/admin/create?" .  $this->_recaptcha_qsencode (array ('domains' => $domain, 'app' => $appname));
	}

	function _recaptcha_aes_pad($val) {
		$block_size = 16;
		$numpad = $block_size - (strlen ($val) % $block_size);
		return str_pad($val, strlen ($val) + $numpad, chr($numpad));
	}

	/* Mailhide related code */

	function _recaptcha_aes_encrypt($val,$ky) {
		if (! function_exists ("mcrypt_encrypt")) {
			die ("To use reCAPTCHA Mailhide, you need to have the mcrypt php module installed.");
		}
		$mode=MCRYPT_MODE_CBC;
		$enc=MCRYPT_RIJNDAEL_128;
		$val=$this->_recaptcha_aes_pad($val);
		return mcrypt_encrypt($enc, $ky, $val, $mode, "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");
	}


	function _recaptcha_mailhide_urlbase64 ($x) {
		return strtr(base64_encode ($x), '+/', '-_');
	}

	/* gets the reCAPTCHA Mailhide url for a given email, public key and private key */
	function recaptcha_mailhide_url($pubkey, $privkey, $email) {
		if ($pubkey == '' || $pubkey == null || $privkey == "" || $privkey == null) {
			die ("To use reCAPTCHA Mailhide, you have to sign up for a public and private key, " .
					 "you can do so at <a href='http://www.google.com/recaptcha/mailhide/apikey'>http://www.google.com/recaptcha/mailhide/apikey</a>");
		}


		$ky = pack('H*', $privkey);
		$cryptmail = $this->_recaptcha_aes_encrypt ($email, $ky);

		return "http://www.google.com/recaptcha/mailhide/d?k=" . $pubkey . "&c=" . $this->_recaptcha_mailhide_urlbase64 ($cryptmail);
	}

	/**
	 * gets the parts of the email to expose to the user.
	 * eg, given johndoe@example,com return ["john", "example.com"].
	 * the email is then displayed as john...@example.com
	 */
	function _recaptcha_mailhide_email_parts ($email) {
		$arr = preg_split("/@/", $email );

		if (strlen ($arr[0]) <= 4) {
			$arr[0] = substr ($arr[0], 0, 1);
		} else if (strlen ($arr[0]) <= 6) {
			$arr[0] = substr ($arr[0], 0, 3);
		} else {
			$arr[0] = substr ($arr[0], 0, 4);
		}
		return $arr;
	}

	/**
	 * Gets html to display an email address given a public an private key.
	 * to get a key, go to:
	 *
	 * http://www.google.com/recaptcha/mailhide/apikey
	 */
	function recaptcha_mailhide_html($pubkey, $privkey, $email) {
		$emailparts = $this->_recaptcha_mailhide_email_parts ($email);
		$url = $this->recaptcha_mailhide_url ($pubkey, $privkey, $email);

		return htmlentities($emailparts[0]) . "<a href='" . htmlentities ($url) .
			"' onclick=\"window.open('" . htmlentities ($url) . "', '', 'toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=0,width=500,height=300'); return false;\" title=\"Reveal this e-mail address\">...</a>@" . htmlentities ($emailparts [1]);

	}

}

/**
 * A ReCaptchaResponse is returned from recaptcha_check_answer()
 */
class HikaShopReCaptchaResponse {
				var $is_valid;
				var $error;
}